unit PIDEExp5;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	ExptIntf, toolintf, virtintf,
	StdCtrls, ComCtrls, ExtCtrls, IniFiles, Editintf,	Buttons, menus;

const hatarolo: string='(; '#13#9#10#0;
const hatarolo1: string='"()[]{},;+=-*&: <>./|@^'#9#0#39#10#13;

type

	TVisibility=(vsNone,vsPublic,vsPrivate,vsProtected,vsPublished);
	TLineType=(vsField,vsMethod,vsProperty);
  TVisib= array[0..7] of integer;

	T_Separator = class(TGraphicControl)
	private
		FBlank: Boolean;
		procedure SetBlank (Value: Boolean);
	protected
		procedure Paint; override;
		procedure SetParent (AParent: TWinControl); override;
	public
		constructor Create (AOwner: TComponent); override;
	published
		property Blank: Boolean read FBlank write SetBlank default False;
	end;

	TLine = class
		Line: longint;
		FClass: Boolean;
		FImplement: boolean;
		FVisibility: TVisibility;
		LineType: TLineType;
	end;

	TPNoti = class(TIAddInNotifier)
  public
		procedure FileNotification(NotifyCode: TFileNotification;
			const FileName: string; var Cancel: Boolean); override; stdcall;
    procedure EventNotification(NotifyCode: TEventNotification;
      var Cancel: Boolean); override; stdcall;
	end;


	TIDEExpert = class(TIExpert)
	private
		{ Private declaration }
		OldDown: Integer;
	protected
		{ Protected declaration }
		TB: TComboBox;
		ST: TTabControl;
		TL: TListBox;
		TEd: TComboBox;
		FEditorName: string;
		MaxLine: longint;
		Items: TStrings;
		TypeStr: TStrings;
		Szint: integer;
		OldPos: TEditPos;
		Page: array[0..3] of TPanel;				{ Ezek a flek ! }
    FEditWindow: TForm;
		procedure GotoPos(Line,Col: longint);
		function  GetPos:TEditPos;
		function  GetCharPos:TCharPos;
		function  GetEditor: TIEditorInterface;
		function  GetLine(Line: longInt): string;
		procedure Insert(EPos: TEditPos;s: string);
		procedure Find(search: string;FItems: TStrings);
		function  GetEditorName: string;
		procedure SetTreeView(FItems: TStrings;Szint: integer);
		procedure ListBoxClear(Items: TStrings);
		procedure Kigyujt(Sender: TObject);
		procedure Click(Sender: TObject);
		procedure SzintClick(Sender: TObject);
		function  IDEWord: string;
		procedure DelphiClick(Sender: TObject);
		procedure ListBoxDrawItem(Control: TWinControl; Index: Integer;
			Rect: TRect; State: TOwnerDrawState);
		procedure DelphiBeszur;
		procedure ClassDrawItem(Control: TWinControl; Index: Integer;
			Rect: TRect; State: TOwnerDrawState);
		procedure PanelResize(Sender: TObject);
		function GetCPos(Line: longint;Col: integer):TCharPos;
		function GetEPos(Line: longint;Col: integer):TEditPos;
		// procedure WinKeyDown(Sender: TObject;var Key: Word; Shift: TShiftState);
		function FindTag(Tag: integer): TComponent;
		procedure ListOnEnter(Sender: TObject);
		function GetEditWindow: TComponent;
		procedure Selected(var sor,hossz: integer);
	public
		{ Public declarations }
		function GetStyle:TExpertStyle; override;
		function GetIDString: string; override;
		function GetName: string; override;
		function GetAuthor: string; override;
		function GetMenuText: string; override;
		function GetState: TExpertState; override;
		function GetGlyph: HICON; override;
		function GetComment: string; override;
		function GetPage: string; override;
		procedure Execute; override;
		procedure FieldClick(Sender: TObject);
		procedure ClassClick(Sender: TObject);
		function CreateButton(x: integer;FParent: TWinControl;FGroupIndex,FTag: integer;FClick: TNotifyEvent; BmpName: string;FHint: string):TSpeedButton;
		function CreateSeparator(x: integer;FParent: TWinControl):T_Separator;
		function CreatePanel(X: integer;FParent:TWinControl): TPanel;
		function CreateHatterPanel(X: integer;FParent:TWinControl): TPanel;
		function CreateLabel(x,y:integer;FParent:TWinControl;FCaption: string):TLabel;
		function CreateEdit(x,y,width:integer;FParent:TWinControl;FName: string):TEdit;
		function CreateComboBox(x,y,width:integer;FParent:TWinControl;FName: string):TComboBox;
		function CreateCheckBox(x,y:integer;FParent:TWinControl;FName,FCaption: string):TCheckBox;
		procedure FindWindow;
		procedure ProjWindow;
		procedure FieldWindow;
		procedure ClassWindow;
	published
  		{ Published declarations }
	end;

procedure Register;

implementation

{$R PIDEEXP.RES}

var TP: TPanel;
		TJ: TPanel;
		TS: TSplitter;
		PNoti: TPNoti;
		FToolServices: TIToolServices;

procedure Register;
begin
	RegisterLibraryExpert(TIDEExpert.Create);
end;


constructor T_Separator.Create (AOwner: TComponent);
begin
	inherited Create (AOwner);
	ControlStyle := ControlStyle - [csOpaque, csCaptureMouse];
	Height:=25;
	Width:=4;
	FBlank:=False;
end;

procedure T_Separator.SetParent (AParent: TWinControl);
begin
	inherited SetParent (AParent);
end;

procedure T_Separator.SetBlank (Value: Boolean);
begin
	if FBlank <> Value then begin
		FBlank := Value;
		Invalidate;
	end;
end;

procedure T_Separator.Paint;
var
	R: TRect;
	Z: Integer;
begin
	inherited Paint;
	with Canvas do begin
		{ Draw dotted border in design mode }
		if csDesigning in ComponentState then
		begin
			Pen.Style := psDot;
			Pen.Color := clBtnShadow;
			Brush.Style := bsClear;
			R := ClientRect;
			Rectangle (R.Left, R.Top, R.Right, R.Bottom);
			Pen.Style := psSolid;
		end;

		if not FBlank then
			 begin
				Z := Width div 2;
				Pen.Color := clBtnShadow;
				MoveTo (Z-1, 0);  LineTo (Z-1, Height);
				Pen.Color := clBtnHighlight;
				MoveTo (Z, 0);  LineTo (Z, Height);
			end;
	end;
end;

procedure TPNoti.EventNotification(NotifyCode: TEventNotification;
      var Cancel: Boolean);
begin
end;      

procedure TPNoti.FileNotification(NotifyCode: TFileNotification;
			const FileName: string; var Cancel: Boolean);
begin
	if NotifyCode=fnProjectClosing then
		begin
		try
		FToolServices.RemoveNotifier(PNoti);
		PNoti.Free;
		TP.Free;
		TJ.Free;
		if Assigned(TS) then
			TS.Free;
		except end;
		TP:=nil;
		TJ:=nil;
		TS:=nil;
		PNoti:=nil;
		end;
end;

function TIDEExpert.GetStyle:TExpertStyle;
begin
	result:=esStandard;
end;

function TIDEExpert.GetIDString: string;
begin
	result:='Pammer.TIDEExpert';
end;

function TIDEExpert.GetName: string;
begin
	result:='Pammer IDE Manager';
end;

function TIDEExpert.GetAuthor: string;
begin
	result:='Pammer Pl';
end;

function TIDEExpert.GetMenuText: string;
begin
	Result:='Pammer IDE Manager';
end;

function TIDEExpert.GetState: TExpertState;
begin
	result:=[esEnabled];
end;

function TIDEExpert.GetGlyph: HICON;
begin
	result:=0;
end;

function TIDEExpert.GetComment: string;
begin
	result:='';
end;

function TIDEExpert.GetPage: string;
begin
	result:='';
end;

procedure TIDEExpert.PanelResize(Sender: TObject);
var i: integer;
		TC: TComponent;
		TW: TWincontrol;

		function OkPage(TW:TWincontrol): Boolean;
		var i: integer;
		begin
			result:=False;
			for i:=0 to 3 do
				begin
				if TW.Parent=Page[i] then
					begin
					result:=True;
					exit;
					end;
				end;
		end;

begin
	for i:=0 to Application.ComponentCount-1 do
		begin
		TC:=Application.Components[i];
		if (TC is TEdit) or (TC is TComboBox) then
			begin
			TW:=TWinCOntrol(TC);
			if (OkPage(TW)) or (OkPage(TW.Parent)) then
				TW.Width:=TJ.Width-TW.Left-5;
			end;
		end;
end;		


function TIDEExpert.CreateButton(x: integer;FParent: TWinControl;FGroupIndex,FTag: integer;FClick: TNotifyEvent; BmpName: string;FHint: string):TSpeedButton;
var B: TBitmap;
		TB: TSpeedButton;
begin
	TB:=TSpeedButton.Create(Application);
	with TB do
		begin
		Flat:=True;			
		Width:=25;
		Height:=25;
		Top:=2;
		Left:=x;
		Parent:=FParent;
		GroupIndex:=FGroupIndex;
		Tag:=FTag;
		OnClick:=FClick;
		if BMPName<>'' then
			begin
			BMPName:=BMPName+#0;
			B:=TBitmap.Create;
			B.Handle:=LoadBitmap(HInstance,@BMPName[1]);
			Glyph.Assign(B);
			B.Free;
			end;
		Hint:=FHint;
		ShowHint:=True;
		end;
	result:=TB;
end;


function TIDEExpert.CreateSeparator(x: integer;FParent: TWinControl):T_Separator;
var st: T_Separator;
begin
	st:=T_Separator.Create(Application);
	st.Parent:=FParent;
	st.Left:=x;
	st.Top:=2;
	result:=st;
end;

function TIDEExpert.CreatePanel(X: integer;FParent:TWinControl): TPanel;
var TPP:TPanel;
begin
	TPP:=TPanel.Create(Application);
	with TPP do
		begin
		BevelInner:=bvLowered;
		BevelOuter:=bvRaised;
		Align:=alTop;
		Height:=29;
		Parent:=FParent;
		end;
	result:=TPP;
end;

function TIDEExpert.CreateHatterPanel(X: integer;FParent:TWinControl): TPanel;
var TPP: TPanel;
begin
	TPP:=CreatePanel(X,FParent);
	TPP.BevelInner:=bvNone;
	TPP.BevelOuter:=bvNone;
	TPP.Align:=alClient;
	result:=TPP;
end;

procedure TIDEExpert.ListOnEnter(Sender: TObject);
var i,k: integer;
		TB: TListBox;
begin
	TB:=TListBox(Sender);
	i:=TB.ItemIndex;
	k:=TB.TopIndex;
	Kigyujt(nil);
	if k<TB.Items.Count then
		TB.TopIndex:=k;
	if i<TB.Items.Count then
		TB.ItemIndex:=i;
end;

procedure TIDEExpert.FindWindow;
var TPP: TPanel;
begin
	if ST<>nil then
		begin
		Page[0]:=CreateHatterPanel(0,TJ);
		TPP:=CreatePanel(0,Page[0]);
		TL:=TListBox.Create(Application);
		TL.Align:=alClient;
		TL.Parent:=Page[0];
		TL.OnEnter:=ListOnEnter;
		// TL.OnClick:=ListOnEnter;
		TL.OnDblClick:=Click;
		TL.Font.Color:=clBlue;
		TL.Style:=lbOwnerDrawFixed;
		TL.OnDrawItem:=ListBoxDrawItem;
		SendMessage(TL.Handle,LB_SETHORIZONTALEXTENT,40*8,0);
		CreateButton(2,TPP,0,7,SzintClick,'PPDELPHI','String az editorbl');
		CreateButton(27,TPP,0,16,SzintClick,'PPPRINTC','Kigyjttt nyomtatsa (*.ctx)');
		TEd:=TComboBox.Create(Application);
		TEd.Left:=55;
		TEd.Text:='';
		TEd.Width:=95;
		TEd.Parent:=TPP;
		TEd.OnExit:=Kigyujt;
		TEd.OnClick:=Kigyujt;
		TEd.Top:=4;
		end;
end;

procedure TIDEExpert.ProjWindow;
begin
	if ST<>nil then
		begin
		Page[1]:=CreateHatterPanel(0,TJ);
		Page[1].Visible:=False;
		end;
end;

function TIDEExpert.CreateLabel(x,y:integer;FParent:TWinControl;FCaption: string):TLabel;
var TL: TLabel;
begin
	TL:=TLabel.Create(Application);
	TL.Parent:=FParent;
	TL.Caption:=FCaption;
	TL.Left:=x;
	TL.Top:=y;
	result:=TL;
end;

function TIDEExpert.CreateEdit(x,y,width:integer;FParent:TWinControl;FName: string):TEdit;
var TE: TEdit;
begin
	TE:=TEdit.Create(Application);
	TE.Parent:=FParent;
	TE.Left:=x;
	TE.Top:=y;
	TE.Width:=Width;
	try
	TE.Name:=FName;
	except
		Application.HandleException(nil);
	end;
	TE.Text:='';
	TE.Height:=18;
	result:=TE;
end;

function TIDEExpert.CreateComboBox(x,y,width:integer;FParent:TWinControl;FName: string):TComboBox;
var TE: TComboBox;
begin
	TE:=TComboBox.Create(Application);
	TE.Parent:=FParent;
	TE.Left:=x;
	TE.Top:=y;
	TE.Width:=Width;
	TE.Height:=21;
	try
		TE.Name:=FName;
	except
		Application.HandleException(nil);
	end;
	TE.Text:='';
	result:=TE;
end;

function TIDEExpert.CreateCheckBox(x,y:integer;FParent:TWinControl;FName,FCaption: string):TCheckBox;
var TE: TCheckBox;
begin
	TE:=TCheckBox.Create(Application);
	TE.Parent:=FParent;
	TE.Left:=x;
	TE.Top:=y;
	try
		TE.Name:=FName;
	except
		Application.HandleException(nil);
	end;
	TE.Caption:=FCaption;
	result:=TE;
end;

function Ellenorzes(mi,miben: string): Boolean;
var n: integer;
		eleje,vege: boolean;
begin
	eleje:=True;
	vege:=True;
	n:=Pos(mi,miben);
	if n>0 then
		begin
		if n>1 then
			eleje:=(Pos(miben[n-1],hatarolo1)>0);
		if n<Length(miben) then
			vege:=(Pos(miben[n+length(mi)],hatarolo1)>0);
		end
	else
		eleje:=False;
	result:=eleje and vege;
end;

procedure TIDEExpert.ClassClick(Sender: TObject);
var i,k: integer;
		s,sz,z: string;
		TC,SSTL: TComboBox;
		TL: TListBox;
		FClass: Boolean;
		FVisib: TVisibility;
		Line: TLine;
		STL: TStrings;

		function SpaceLe(z: string): string;
		begin
			{ Els tabok, spacok leszedse }
			while (z<>'') and ((z[1]=' ') or (z[1]=#9)) do
				z:=Copy(z,2,255);
			result:=z;
		end;

		function Leszed(z: string):string;
		var i: integer;
		begin
			{ z:=SpaceLe(z); }
			i:=1;
			while (i<Length(z)) and (Pos(z[i],Hatarolo1)=0) do
				i:=i+1;
			z:=Copy(z,i,255);
			z:=SpaceLe(z);
			{ A sor vgrl a sallangok leszedse }
			i:=Pos('(',z);
			if i=0 then		{ Nem fggvny, teht a ; a hatr ! }
				begin
				i:=Pos(';',z);
				if i>0 then
					z:=Copy(z,1,i);
				end;
			i:=Pos(')',z);
			if i>0 then
				z:=Copy(z,1,i+1);
			result:=z;
		end;

		function LineFind(s: string): integer;
		var i: integer;
		begin
			s:=SpaceLe(s);
			for i:=0 to Items.Count-1 do
				begin
				if (Pos(s,Items[i])>0) and (TLine(Items.Objects[i]).FImplement) then
					begin
					result:=i;
					exit;
					end;
				end;
			result:=-1;
		end;

begin
  // Osztlyparamterek kigyjtse
	TL:=TListBox(Application.FindComponent('PP_CLASSLIST'));
	if TL=nil then
		exit;
	STL:=TStringList.Create;
	TL.Items.Clear;
	TC:=TComboBox(Sender);
	if TC.ItemIndex>=0 then
		begin
		FClass:=False;
		FVisib:=vsPublic;
		s:=trim(lowercase(TC.Items[TC.ItemIndex]));		{ Osztly }
		for i:=0 to TypeStr.Count-1 do
			begin
			sz:=lowercase(TypeStr[i]);
			if Ellenorzes(s,sz) then
				begin
				FClass:=True;
				continue;
				end;
			if FClass then
				begin
				if Ellenorzes('end',sz) then
					break;
				if Ellenorzes('private',sz) then
					begin
					FVisib:=vsPrivate;
					continue;
					end;
				if Ellenorzes('protected',sz) then
					begin
					FVisib:=vsProtected;
					continue;
					end;
				if Ellenorzes('public',sz) then
					begin
					FVisib:=vsPublic;
					continue;
					end;
				if Ellenorzes('published',sz) then
					begin
					FVisib:=vsPublished;
					continue;
					end;
				Line:=TLine(TypeStr.Objects[i]);
				Line.FVisibility:=FVisib;
				Line.LineType:=vsField;
				z:=SpaceLe(TypeStr[i]);
				if Ellenorzes('property',sz) then
					begin
					Line.LineType:=vsProperty;
					z:=Leszed(z);
					k:=LineFind(z);
					if k>-1 then
						Line.Line:=TLine(Items.Objects[k]).Line;
					end;
				if (Ellenorzes('procedure',sz)) or (Ellenorzes('function',sz)) or
					(Ellenorzes('constructor',sz)) or (Ellenorzes('destructor',sz)) then
					begin
					Line.LineType:=vsMethod;
					z:=Leszed(z);
					k:=LineFind(z);
					if k>-1 then
						Line.Line:=TLine(Items.Objects[k]).Line;
					end;
				if z<>'' then
					STL.AddObject(z,Line);
				end;
			end;
		SSTL:=TComboBox.Create(nil);
		SSTL.Visible:=False; 
		SSTL.Parent:=TL;
		SSTL.Sorted:=True;
		for k:=0 to 2 do
			begin
			SSTL.Items.Clear;
			for i:=0 to STL.Count-1 do
				begin
				if TLine(STL.Objects[i]).LineType=TLineType(k) then
					SSTL.Items.AddObject(STL[i],TLine(STL.Objects[i]));
				end;
			for i:=0 to SSTL.Items.Count-1 do
				TL.Items.AddObject(SSTL.Items[i],TLine(SSTL.Items.Objects[i]));
			end;
		STL.Free;
		SSTL.Free;
		end;
end;

procedure TIdeExpert.ClassDrawItem(Control: TWinControl; Index: Integer;
	Rect: TRect; State: TOwnerDrawState);
var s: string;
		FLine: TLine;
		ListBox: TListBox;
		B: TBitmap;
		BName: string;
		R: TRect;
begin
	ListBox:=TListBox(Control);
	s:=ListBox.Items[Index]+#0;
	FLine:=TLine(ListBox.Items.Objects[Index]);
	if odSelected in State then
		begin
		ListBox.Canvas.Brush.Color:=clHighLight;
		ListBox.Canvas.Font.Color:=clHighLightText;
		end;
	BName:='PPPUB';
	if FLine.FVisibility=vsPrivate then
		BName:='PPPRIV';
	if FLine.FVisibility=vsProtected then
		BName:='PPPROT';
	if FLine.LineType=vsField then
		BName:=BName+'FIELD';
	if FLine.LineType=vsMethod then
		BName:=BName+'METH';
	if FLine.LineType=vsProperty then
		BName:=BName+'PROP';
	BName:=BName+#0;
	B:=TBitmap.Create;
	B.Handle:=LoadBitmap(HInstance,@BName[1]);
	ListBox.Canvas.FillRect(Rect);
	R:=Rect;
	R.Left:=2;
	R.Right:=R.Left+B.Width;
	R.Top:=Rect.Top+((Rect.Bottom-Rect.Top)-B.Height) div 2;
	R.Bottom:=R.Top+B.Height;
	ListBox.Canvas.BrushCopy(R,B,Bounds(0,0,B.Width,B.Height),B.Canvas.Pixels[0,0]);
	Rect.Left:=Rect.Left+25;
	DrawText(ListBox.Canvas.Handle,@s[1],-1,Rect,DT_VCENTER or DT_LEFT or DT_EXPANDTABS or DT_NOCLIP);
	B.Free;
end;


procedure TIDEExpert.ClassWindow;
var TPP: TPanel;
		TL: TListBox;
		TC: TComboBox;
begin
	if ST<>nil then
		begin
		Page[3]:=CreateHatterPanel(0,TJ);
		Page[3].Visible:=False;
		TPP:=CreatePanel(0,Page[3]);
		CreateLabel(5,8,TPP,'Class:');
		TC:=CreateCombobox(40,4,110,TPP,'PP_CLASSTYPE');
		TC.Style:=csDropDownList;
		TC.OnDropDown:=Kigyujt;
		TC.OnClick:=ClassClick;
		TL:=TListBox.Create(Application);
		TL.Name:='PP_CLASSLIST';
		TL.Align:=alClient;
		TL.Parent:=Page[3];
		TL.OnDblClick:=Click; 
		TL.Font.Color:=clBlue;
		TL.Style:=lbOwnerDrawFixed;
		TL.OnDrawItem:=ClassDrawItem;
		SendMessage(TL.Handle,LB_SETHORIZONTALEXTENT,40*8,0);
		{ TL.Sorted:=True; }
		end;
end;

procedure TIDEExpert.FieldWindow;
const Visib: array[0..3] of string[20]=('Private','Protected','Public','Published');
			Muvelet: array[0..2] of string[20]=('Method','Field','Property');
			Get: array[0..2] of string[20]=('','Direct','Get..');
			Meth: array[0..3] of string[20]=('procedure','function','constructor','destructor');

var TPP: TPanel;
		TC,TCo: TComboBox;
		i: integer;
		// INI: TIniFile;
		// s: string;
begin
	if ST<>nil then
		begin
		// s:=ExtractFilePath(Application.ExeName)+'pideexp.ini';
		// INI:=TIniFile.Create(s);
		Page[2]:=CreateHatterPanel(0,TJ);
		Page[2].Visible:=False;
		TPP:=CreatePanel(0,Page[2]);
		CreateButton(2,TPP,0,13,SzintClick,'PPUNDO','Elem beszrsa a forrsba');
		TCo:=CreateCombobox(30,4,120,TPP,'PP_COMBOTYPE');
		for i:=0 to 2 do
			TCo.Items.Add(Muvelet[i]);
		TCo.OnClick:=FieldClick;
		TCo.ItemIndex:=0;
		CreateLabel(5,35,Page[2],'Name:');
		CreateEdit(70,32,80,Page[2],'PP_EDIT2');
		CreateLabel(5,60,Page[2],'Add to Class:');
		CreateCombobox(70,57,80,Page[2],'PP_COMBO1');
		CreateLabel(5,85,Page[2],'Type:');
		TC:=CreateCombobox(70,82,80,Page[2],'PP_COMBO2');
		TC.Sorted:=True;
		// Ini.ReadSection('Type',TC.Items);
    TC.Items.Text:='Bool'+#13+'Boolean'+#13+'Byte'+#13+'Cardinal'+#13+'Char'+#13+'Double'+#13+'DWORD'+
    	#13+'Extended'+#13+'Integer'+#13+'Longint'+#13+'PChar'+#13+'Pointer'+#13+'PWideChar'+#13+'Real'+#13+'ShortInt'+
      #13+'Single'+#13+'SmallInt'+#13+'String'+#13+'TClass'+#13+'THeader'+#13+'TMessage'+#13+'TObjects'+#13+'WideChar'+#13+'WORD';


		CreateLabel(5,110,Page[2],'Visibility:');
		TC:=CreateCombobox(70,108,80,Page[2],'PP_COMBO3');
		for i:=0 to 3 do
			TC.Items.Add(Visib[i]);
		TC.ItemIndex:=0;
		CreateLabel(5,135,Page[2],'Get Property:');
		TC:=CreateCombobox(70,133,80,Page[2],'PP_COMBO4');
		for i:=0 to 2 do
			TC.Items.Add(Get[i]);
		CreateLabel(5,160,Page[2],'Set Property:');
		TC:=CreateCombobox(70,158,80,Page[2],'PP_COMBO5');
		for i:=0 to 2 do
			TC.Items.Add(Get[i]);
		TC.Items[2]:='Set...';
		CreateLabel(5,185,Page[2],'Method Type:');
		TC:=CreateCombobox(72,182,80,Page[2],'PP_COMBO6');
		for i:=0 to 3 do
			TC.Items.Add(Meth[i]);
		TC.ItemIndex:=0;
		CreateLabel(5,210,Page[2],'Parameters:');
		TC:=CreateCombobox(72,207,80,Page[2],'PP_COMBO7');
		TC.Sorted:=True;
    TC.Items.Text:='AOwner: TComponent'+#13+'Sender: TObject';
    {
		i:=1;
		while (True) do
			begin
			s:=Ini.ReadString('Params','p'+intToStr(i),'');
			if s='' then
				break;
			TC.Items.Add(s);
			i:=i+1;
			end;
    }  
		CreateCheckBox(5,235,Page[2],'PP_CHECK1','Abstract');
		CreateCheckBox(70,235,Page[2],'PP_CHECK2','Virtual');
		CreateCheckBox(5,255,Page[2],'PP_CHECK3','Override');
		CreateCheckBox(70,255,Page[2],'PP_CHECK4','Call inherited');
		FieldClick(TCo);
		// Ini.Free;
		end;
end;

function TIDEExpert.FindTag(Tag: integer): TComponent;
var i: integer;
begin
	result:=nil;
	for i:=0 to Application.ComponentCount-1 do
		begin
		if TWinControl(Application.Components[i]).Tag=Tag then
			begin
			result:=Application.Components[i];
			break;
			end;
		end;
end;

(*
procedure TIDEExpert.WinKeyDown(Sender: TObject;var Key: Word; Shift: TShiftState);
const Tags:array[0..3] of integer=(4,11,12,14);
var i: integer;
		TB: TSpeedButton;
		TT: TListBox;
begin
	if (Key=ord('Z')) and (Shift=[ssAlt]) then
		DelphiClick(nil);
	if (Shift=[ssShift,ssCtrl]) and (TJ.Visible) then
		begin
		TT:=nil;
		if Page[0].Visible then
			TT:=TL;
		if Page[3].Visible then
			TT:=TListBox(Application.FIndCOmponent('PP_CLASSLIST'));
		if (TT<>nil) and (GetFocus<>TT.Handle) then
			begin
			if (Key=VK_UP) then
				TT.ItemIndex:=TT.ItemIndex-1;
			if (Key=VK_DOWN) then
				TT.ItemIndex:=TT.ItemIndex+1;
			if Key=VK_RETURN then
				Click(TT);
			end;
		end;
	if (Key=VK_F5) and (Shift=[ssAlt]) and (TP<>nil) then
		begin
		if TJ.Visible then
			begin
			for i:=0 to 3 do
				begin
				TB:=TSpeedButton(FindTag(Tags[i]));
				if (TB<>nil) and (TB.Down) then
					begin
					OldDown:=Tags[i];
					TB.Down:=False;
					SzintClick(TB);
					break;
					end;
				end;
			end
		else
			begin
			TB:=TSpeedButton(FindTag(OldDown));
			if (TB<>nil) then
				begin
				TB.Down:=True;
				SzintClick(TB);
				end;
			end;
		end;
end;
*)


function TIDEExpert.GetEditWindow: TComponent;
var i  : integer;
		// Items: TStrings;

		{
		procedure CompGyujt(Comp: TComponent);
		var n: integer;
				s: string;
		begin
			for n:=0 to Comp.ComponentCount-1 do
				begin
				s:=Comp.Components[n].Name+':('+Comp.Components[n].ClassName+')';
				Items.Add(s);
				CompGyujt(Comp.Components[n]);
				end;
		end;
		}

begin
		result:=nil;

		for i:=0 to screen.FormCount-1 do
			begin
			if Screen.Forms[i].Classname='TEditWindow' then
				begin
				result:=screen.Forms[i];
				break;
				end;
			end;
end;

procedure TIDEExpert.Selected(var sor,hossz: integer);
var Editor: TIEditorInterface;
		EPos: TEditPos;
		CPos: TCharPos;
		x,y: TPoint;
begin
	Editor:=GetEditor;
	if Editor<>nil then
		begin
		CPos:=Editor.GetBlockStart;
		Editor.GetView(0).ConvertPos(False,EPos,CPos);
		x.x:=EPos.Line+1;
		x.y:=EPos.Col;
		CPos:=Editor.GetBlockAfter;
		Editor.GetView(0).ConvertPos(False,EPos,CPos);
		y.x:=EPos.Line+1;
		y.y:=EPos.Col;
		ShowMessage(Format('Start: %d-%d After: %d-%d',[x.x,x.y,y.x,y.y]));
		end;
end;

procedure TIDEExpert.Execute;
const FHint: array[0..2] of string=('Osztlyok','Osztly fggvnyek','Implementcis fggvnyek');
var j: integer;
		TC: TComponent;
		TBu: TSpeedButton;
begin
	TC:=GetEditWindow;
	if TC=nil then
		exit;
	FEditWindow:=TForm(TC);
	if Assigned(TP) then
		begin
		try
		(*
		if FEditWindow<>nil then
			begin
			FEditWindow.OnKeyDown:=nil;
			FEditWindow.KeyPreview:=False;
			end;
		*)
		ToolServices.RemoveNotifier(PNoti);
		ListBoxClear(Items);
		Items.Free;
		TypeStr.Free;
		TP.Free;
		TP:=nil;
		if Assigned(TJ) then
			begin
			if Assigned(TS) then
				begin
				TS.Free;
				TS:=nil;
				end;
			TJ.Free;
			TJ:=nil;
			end;
		except end;
    // ShowMessage('Kikapcsolva!');
		exit;
		end;
    { Keressk meg az editor ablakt ! }
		if TC=nil then
			begin
			ShowMessage('Nem talltam meg az editort!');
			Exit;
			end;
		(*
		with (FEditWindow) do
			begin
			// Megnzni a komponenseket rajta !
			{
			for i:=0 to ComponentCount-1 do
				ShowMessage(Components[i].ClassName+' - '+Components[i].Name);
			OnKeyDown:=WinKeyDown;
			KeyPreview:=True;
			}
			end;
		*)
		FToolServices:=ToolServices;
		OldDown:=14;
		PNoti:=TPNoti.Create;
		ToolServices.AddNotifier(PNoti);
		St:=nil;
		{$IFDEF VER100}				// DELPHI 3
		St:=TTabControl(TC.FindComponent('TabControl')); // DELPHI 3.0
		{$ELSE}               // DELPHI 4, 5
		St:=TTabControl(TC.FindComponent('Panel1'));        // DELPHI 5.0
		{$ENDIF}
		if ST<>nil then
			begin
			TJ:=TPanel.Create(Application);
			TJ.PArent:=ST;
			TJ.Align:=alRight;
			TJ.Visible:=False;
			TJ.BevelInner:=bvNone;
			TJ.BevelOuter:=bvNone;
			TJ.Width:=155;
			TJ.OnResize:=PanelResize;

			{ Jobb oldali panel krelsa }
			FindWindow;
			ProjWindow;
			FieldWindow;
			ClassWindow;

			TP:=CreatePanel(0,ST);
			{ A comboBox megkrelsa }
			TB:=TComboBox.Create(TP);
			TB.Parent:=TP;
			TB.Width:=180;
			TB.Style:=csDropDownList;
			TB.Height:=18;
			TB.Top:=(TP.Height-TB.Height) div 2;
			TB.Left:=90;
			TB.OnDropDown:=Kigyujt;
			TB.Font.Color:=clBlue;
			TB.OnClick:=Click;
			TB.Sorted:=True;
			CreateButton(2,TP,0,5,SzintClick,'PPREFRES','Adatok frisstse');
			CreateSeparator(29,TP);
			CreateButton(35,TP,0,6,SzintClick,'PPUNDO','Elugrs a kijellt sorra!');
			CreateButton(60,TP,0,0,DelphiClick,'PPDELPHI','String az editor ablakbl');
			// Kivve az EXIT gomb !!!!
			// TBu:=CreateButton(1,TP,0,8,SzintClick,'PPEXIT','Expert lezrsa');
			// TBu.Align:=alRight;
			Items:=TStringList.Create;
			TypeStr:=TStringList.Create;
			{ Gombok krelsa }
			CreateSeparator(274,TP);
			CreateSeparator(358,TP);
			for j:=0 to 2 do
				begin
				TBu:=CreateButton(280+j*25,TP,1,j+1,SzintClick,'PPCLASS'+IntToSTr(j),FHint[j]);
				if j=2 then
					TBu.Down:=True;
				end;
			TBu:=CreateButton(365,TP,3,4,SzintClick,'PPCLASS3','Keress');
			TBu.AllowAllUp:=True;
			TBu:=CreateButton(390,TP,3,12,SzintClick,'PPEDIT','j definicik');
			TBu.AllowAllUp:=True;
			{
			TBu:=CreateButton(415,TP,3,11,SzintClick,'PPPROJECT','Project betltse');
			TBu.AllowAllUp:=True;
			}
			TBu:=CreateButton(415,TP,3,14,SzintClick,'PPCLASSES','Osztly felpts');
			TBu.AllowAllUp:=True;
			TBu.Hint:='Osztlyok megjelentse';
			Tbu.ShowHint:=True;
			{
			CreateSeparator(443,TP);
			CreateButton(450,TP,0,15,SzintClick,'PPPRINT','Nyomtats');
			}
			// CreateButton(475,TP,0,16,SzintClick,'PPPRINTC','Class nyomtats');
			szint:=2;
			end;
end;



procedure TIdeExpert.ListBoxDrawItem(Control: TWinControl; Index: Integer;
	Rect: TRect; State: TOwnerDrawState);
var s: string;
		FLine: TLine;
		ListBox: TListBox;
begin
	ListBox:=TListBox(Control);
	s:=ListBox.Items[Index]+#0;
	FLine:=TLine(ListBox.Items.Objects[Index]);
	if odSelected in State then
		begin
		ListBox.Canvas.Brush.Color:=clHighLight;
		ListBox.Canvas.Font.Color:=clHighLightText;
		end;
	{ if FLine.FClass then }
	if not FLine.FImplement then
		ListBox.Canvas.Font.Style:=ListBox.Canvas.Font.Style+[fsItalic]
	else
		ListBox.Canvas.Font.Style:=ListBox.Canvas.Font.Style-[fsItalic];
	ListBox.Canvas.FillRect(Rect);
	DrawText(ListBox.Canvas.Handle,@s[1],-1,Rect,DT_VCENTER or DT_LEFT or DT_EXPANDTABS or DT_NOCLIP);
end;

function TIDEExpert.GetCPos(Line: longint;Col: integer):TCharPos;
var Editor: TIEditorInterface;
		CPos: TCharPos;
		EPos: TEditPos;
begin
	CPos.Line:=1;
	CPos.CharIndex:=1;
	EPos.Line:=Line;
	EPos.Col:=Col;
	Editor:=GetEditor;
	if Editor<>nil then
		Editor.GetView(0).ConvertPos(True,EPos,CPos);
	result:=CPos;
end;

function TIDEExpert.GetEPos(Line: longint;Col: integer):TEditPos;
var Editor: TIEditorInterface;
		EPos: TEditPos;
		CPos: TCharPos;
begin
	CPos.Line:=Line;
	CPos.CharIndex:=Col;
	EPos.Line:=1;
	EPos.Col:=1;
	Editor:=GetEditor;
	if Editor<>nil then
		Editor.GetView(0).ConvertPos(False,EPos,CPos);
	result:=EPos;
end;


procedure TIDEExpert.DelphiBeszur;
var i,j,n,FType: integer;
		s,sz,c1,c2,e2: string;
		FLine: LongInt;
		FClass,Remark: boolean;
		ClassLine: array[0..3,0..2] of longint;
		c3,c4,c5,c6,c7: TCombobox;
		ch1,ch2,ch3,ch4: TCheckBox;
		TEPos: TEditPos;

		procedure Betesz(Line: longint;sz: string);
		var TEPos: TEditPos;
				j: integer;
				s: string;
		begin
			s:=GetLine(Line-1);
			TEPos:=GetEPos(Line-1,Length(s)+2);
			{ Az elz sor elejn lv tabok, spacok levtele }
			j:=1;
			while (j<=Length(s)) do
				begin
				if (s[j]<>#9) and (s[j]<>' ') then
					break;
				j:=j+1;
				end;
			Insert(TEPos,#13#10+Copy(s,1,j-1)+sz);
		end;

		procedure LineBetesz(line: longint);
		begin
			if ClassLine[FType][1]=-1 then
				ClassLine[FType][1]:=Line;
			if ClassLine[FType][2]=-1 then
				ClassLine[FType][2]:=Line;
		end;

		procedure Lepes(Ty: integer);
		begin
				LineBetesz(FLine);
				FType:=Ty;
				ClassLine[FType][0]:=FLine;
		end;

		function GetMethod(Vege: Boolean): string;
		var s,sz,param: string;
		begin
    	param:=c7.Text;
			s:=c6.Text+' ';
			if Vege then
				s:=s+c1+'.';
			if c6.ItemIndex<2 then
				begin
				s:=s+e2;
				if c7.Text<>'' then
					s:=s+'('+c7.Text+')';
				if c6.ItemIndex=1 then
					s:=s+': '+c2
				end;
			if c6.ItemIndex=2 then
				begin
        e2:='Create';
				s:=s+'Create';
				if param<>'' then
					s:=s+'('+param+')';
				end;
			if c6.ItemIndex=3 then
      	begin
				s:=s+'Destroy';
        e2:='Destroy';
        param:='';						// Nem lehet paramter
        end;
			if (ch2.Checked and (not Vege)) then
				s:=s+' ;virtual';
			if (ch1.Checked and (not Vege)) then
				s:=s+' ;abstract';
			if (ch3.Checked and (not Vege)) then
				s:=s+' ;override';
			s:=s+';';
			if vege then
				begin
				sz:=#9;
				if ch4.Checked then
					begin
					sz:=#9+'inherited '+e2;
					if param<>'' then
						sz:=sz+'('+param+')';
					sz:=sz+';'+#13#10#9;
					end;
				s:=#13#10+s+#13#10+'begin'+#13#10+sz+#13#10+'end;'+#13#10#13#10;
				end;
			result:=s;
		end;

		procedure Beiras;
		var i: integer;
		begin
			if ClassLine[n][0]=ClassLine[n][j]-1 then
					s:=#9+s;
			Betesz(ClassLine[n][j],s);
			MaxLine:=MaxLine+1;
			{ A htrbb lvk eltolsa }
			for i:=j+1 to 2 do
				ClassLine[n][i]:=ClassLine[n][i]+1;
			for i:=n+1 to 3 do
				begin
				inc(ClassLine[i][0]);
				inc(ClassLine[i][1]);
				inc(ClassLine[i][2]);
				end;
		end;

		procedure Vegere(s: string;sor: integer);
		var j,i: integer;
				sz: string;
		begin
			j:=MaxLine+1;
			while (j>=1) do
				begin
				sz:=lowercase(GetLine(j));
				if Ellenorzes('end.',sz) then
					break;
				j:=j-1;
				end;
			TEPos.Line:=j;
			TEpos.Col:=1;
			Insert(TEPos,s);
			TEPos:=GetEPos(j+sor,1);
			GotoPos(j+sor,TEPos.Col);
			j:=0;
			i:=0;
			while (j<Length(s)) do
				begin
				if s[j]=#13 then
					i:=i+1;
				j:=j+1;
				end;
			MaxLine:=MaxLine+i;
		end;

		function GetProperty: string;
		var c4i,c5i: integer;
				sz: string;
		begin
			c4i:=-1;
			c5i:=-1;
			if (ch1.Checked) then
				begin
				n:=0;		{ Private vltoz lesz belle ! }
				j:=1;
				s:='F'+e2+': '+c2+';';
				Beiras;
				n:=c3.ItemIndex;	{ Visibility }
				end;
			s:='property '+e2+': '+c2;
			if (c4.Text<>'') then
				begin
				c4i:=c4.Items.IndexOf(c4.Text);
				if c4i=0 then
					s:=s+' read '+c4.Text;
				if (c4i=1) then
					s:=s+' read F'+e2;
				if (c4i=2) then
					s:=s+' read Get'+e2;
				end;
			if (c5.Text<>'') then
				begin
				c5i:=c5.Items.IndexOf(c5.Text);
				if c5i=0 then
					s:=s+' write '+c5.Text;
				if (c5i=1) then
					s:=s+' write F'+e2;
				if (c5i=2) then
					s:=s+' write Set'+e2;
				end;
			s:=s+';';
			n:=3;
			j:=2;
			Beiras;
			n:=1;			{ Private -ba ! }
			{ Set; Get megrsa }
			sz:='';
			if (c4i=2) then
				begin
				s:='function Get'+e2+': '+c2+';';
				Beiras;
				sz:='function '+c1+'.Get'+e2+': '+c2+';';
				sz:=sz+#13#10+'begin'+#13#10#9+'result:=F'+e2+';'+#13#10+'end;'+#13#10#13#10;
				end;
			if (c5i=2) then
				begin
				s:='procedure Set'+e2+'(Value: '+c2+');';
				Beiras;
				sz:=sz+'procedure '+c1+'.Set'+e2+'(Value: '+c2+');';
				sz:=sz+#13#10+'begin'+#13#10#9+'if Value<>F'+e2+' then'+#13#10#9#9+'begin'+#13#10#9#9+'F'+e2+':=Value;'+
        	#13#10#9#9+'end;'+#13#10+'end;'+#13#10#13#10;
				end;
			if sz<>'' then
				Vegere(sz,2);
			result:=s;
		end;


begin
		Find('',Items);
		with Application do
		begin
		e2:=TEdit(FindComponent('PP_EDIT2')).Text;
		c1:=TCOmboBox(FindComponent('PP_COMBO1')).Text;
		c2:=TCOmboBox(FindComponent('PP_COMBO2')).Text;
		c3:=TCOmboBox(FindComponent('PP_COMBO3'));
		c4:=TCOmboBox(FindComponent('PP_COMBO4'));
		c5:=TCOmboBox(FindComponent('PP_COMBO5'));
		c6:=TCOmboBox(FindComponent('PP_COMBO6'));
		c7:=TCOmboBox(FindComponent('PP_COMBO7'));
		ch1:=TCheckBox(FindComponent('PP_CHECK1'));
		ch2:=TCheckBox(FindComponent('PP_CHECK2'));
		ch3:=TCheckBox(FindComponent('PP_CHECK3'));
		ch4:=TCheckBox(FindComponent('PP_CHECK4'));
		if c1<>'' then		{ Pozicik, sorok megkeresse }
			begin
			{ ClassLine nullzsa ! }
			for i:=0 to 3 do
				begin
				ClassLine[i][0]:=-1;
				ClassLine[i][1]:=-1;
				ClassLine[i][2]:=-1;
				end;
			s:=Lowercase(Trim(c1));
			FClass:=False;
			Remark:=False;
			for i:=0 to TypeStr.Count-1 do
				begin
				sz:=lowercase(TypeStr[i]);
				FLine:=TLine(TypeStr.Objects[i]).Line;
				n:=Pos('{',sz);
				j:=Pos('}',sz);
				if (n>0) and (j>0) then
					begin
					sz:=Copy(sz,1,n)+Copy(sz,j+1,255);
					Remark:=False;
					end;
				if (n>0) and (j=0) then
					begin
					sz:=Copy(sz,1,n);
					Remark:=True;
					end;
				if (n=0) and (j>0) then
					begin
					sz:=Copy(sz,j+1,255);
					Remark:=False;
					end;
				if (not Remark) and (not FClass) and (Ellenorzes(s,sz)) then
					begin
					FClass:=True;
					FType:=2;				{ Public a kezd tpus ! }
					ClassLine[FType][0]:=FLine;
					end;
				if ((not Remark) and FClass) then
					begin
					if Ellenorzes('end',sz) then
						begin
						LineBetesz(FLine);
						break;
						end;
					if (Ellenorzes('procedure',sz)) or (Ellenorzes('function',sz)) or
						(Ellenorzes('constructor',sz)) or (Ellenorzes('destructor',sz)) or (Ellenorzes('property',sz)) then
						begin
						if ClassLine[FType][1]=-1 then
							ClassLine[FType][1]:=FLine;
						end;
					if Ellenorzes('private',sz) then
						Lepes(0);
					if Ellenorzes('protected',sz) then
						Lepes(1);
					if Ellenorzes('public',sz) then
						begin
						Lepes(2);
						ClassLine[FType][1]:=-1;
						ClassLine[FType][2]:=-1;
						end;
					if Ellenorzes('published',sz) then
						Lepes(3);
					end;
				end;
			end;
		{ *******************************************}
		n:=c3.ItemIndex;	{ Visibility }
		if ClassLine[n][1]=-1 then
			ShowMessage('Nem talltam meg a helyet!')
		else
			begin
			i:=TComboBox(FindComponent('PP_COMBOTYPE')).ItemIndex;
			j:=1;
			if i=0 then		{ Methode }
				begin
				j:=2;
				s:=GetMethod(False);
				Beiras;
				s:=GetMethod(True);
				j:=3;
				if ch4.Checked then
					j:=4;
				Vegere(s,j);
				end;
			if i=1 then		{ Uj field ! }
				begin
				j:=1;
				s:=e2+': '+c2+';';
				Beiras;
				end;
			if (i=2) then
				s:=GetProperty;
			end;
		end;
end;

procedure TIDEExpert.SzintClick(Sender: TObject);
var s: string;
		TTS: TStrings;
		i,n: integer;
		Kell: Boolean;

	procedure JobbVisible;
	begin
		if TJ.Visible then
			begin
			if TS=nil then
				begin
				TS:=TSplitter.Create(Application);
				TS.Align:=alRight;
				TS.Parent:=ST;
				end;
			end
		else
			begin
			TS.Free;
			TS:=nil;
			end;
	end;

	procedure ActivePage(Index: integer);
	var i: integer;
	begin
		if TJ.Visible then
			begin
			for i:=0 to 3 do
				Page[i].Visible:=(i=Index);
			end;
	end;

begin
	s:=Uppercase(TWinControl(Sender).Name);
	case TWinControl(Sender).Tag of
		1,2,3: Szint:=TWinControl(Sender).Tag-1;
		4,11,12,14:	begin
				TJ.Visible:=TSpeedButton(Sender).Down;
				JobbVisible;
				case TWinControl(Sender).Tag of
					4:	ActivePage(0);
					11: ActivePage(1);
					12: ActivePage(2);
					14: ActivePage(3);
				end;
				end;
		6: 	begin
				if OldPos.Line>0 then
					GotoPos(OldPos.Line,OldPos.Col);
				exit;
				end;
		7:  begin
				TEd.Text:=IDEWord;
				end;
		8:  begin
				Execute;
				exit;
				end;
		13: begin
				DelphiBeszur;
				exit;
				end;
		15: begin
				Selected(i,n);
				exit;			{ Nyomtats }
				end;
		16: begin			{ Kigyjts nyomtatsa }
				Kell:=False;
				if MessageDlg('Sorszmokat is lementsem ?',mtConfirmation, [mbYes, mbNo], 0) = mrYes then
					Kell:=True;
				TTS:=TStringList.Create;
				for i:=0 to TL.Items.Count-1 do
					begin
					if Kell then
						TTS.Add(Format('%5d %s',[TLine(TL.Items.Objects[i]).Line,TL.Items[i]]))
					else
						TTS.Add(Format('%s',[TL.Items[i]]));
					end;
				s:=GetEditorName;
				s:=ChangeFileExt(s,'.ctx');
				TTS.SaveToFile(s);
				TTS.Free;
				exit;
				end;
		end;
	Kigyujt(nil);
end;

procedure TIDEExpert.FieldClick(Sender: TObject);
const TComp:array[0..7] of string[20]=('PP_COMBO4','PP_COMBO5','PP_COMBO6','PP_COMBO7',
	'PP_CHECK1','PP_CHECK2','PP_CHECK3','PP_CHECK4');
	Visib: array[0..2] of TVisib=((0,0,1,1,1,1,1,1),(0,0,0,0,0,0,0,0),(1,1,0,0,1,0,0,0));
	// Capt:array[0..1] of string=('Abstract','Create Field');
var i: integer;
begin
	try
		for i:=0 to 7 do
			TWinControl(Application.Findcomponent(TComp[i])).Visible:=(Visib[TComboBox(Sender).ItemIndex][i]=1);
		if TComboBox(Sender).ItemIndex=0 then
			TCheckBox(Application.Findcomponent('PP_CHECK1')).Caption:='Abstract'
		else
			TCheckBox(Application.Findcomponent('PP_CHECK1')).Caption:='Create Field';
		TCheckBox(Application.Findcomponent('PP_CHECK1')).Checked:=not (TComboBox(Sender).ItemIndex=0);
	except
		Application.HandleException(nil);
	end;
	if TComboBox(Application.FindComponent('PP_COMBOTYPE')).ItemIndex=2 then
		TComboBox(Application.FindComponent('PP_COMBO3')).ItemIndex:=3;
end;

procedure TIDEExpert.Click(Sender: TObject);
begin
	if TComboBox(Sender).ItemIndex<0 then
		exit;
	if Sender is TComboBox then
		GotoPos(TLine(TComboBox(Sender).Items.Objects[TComboBox(Sender).ItemIndex]).Line,1);
	if Sender is TListBox then
		GotoPos(TLine(TListBox(Sender).Items.Objects[TListBox(Sender).ItemIndex]).Line,1);
end;

procedure TIDEExpert.DelphiClick(Sender: TObject);
var s: string;
		i: integer;
begin
		OldPos:=GetPos;
		Kigyujt(nil);
		s:=Uppercase(IDEWord);
		if s<>'' then
			begin
			for i:=0 to TB.Items.Count-1 do
				begin
				if Ellenorzes(s,Uppercase(TB.Items[i])) then
					begin
					TB.ItemIndex:=i;
					Click(TB);
					break;
					end;
				end;
			end;
end;


function TIDEExpert.IDEWord: string;
var s: string;
		i,n,e,v: integer;
		CPos: TCharPos;
		hatar: string;
begin
	hatar:=hatarolo1;
	CPos:=GetCharPos;
	s:=GetLine(CPos.Line);
	n:=CPos.CharIndex+1;	{ Oszlop! }
	{ Elejnek a megkeresse }
	e:=0;
	for i:=n downto 1 do
		begin
		if Pos(s[i],hatar)>0 then
			begin
			e:=i;
			break;
			end;
		end;
	e:=e+1;
	v:=0;
	{ Vge megkeresse }
	for i:=n to Length(s) do
		begin
		if Pos(s[i],hatar)>0 then
			begin
			v:=i;
			break;
			end;
		end;
		if v=0 then
			v:=Length(s)+1;
		s:=Copy(s,e,v-e);
		result:=s;
end;

procedure TIDEExpert.Kigyujt(Sender: TObject);
var s,sz: string;
		i: integer;
		TC,TC1: TComboBox;
		CPos: TEditPos;
		van: Boolean;
begin
	i:=TB.ItemIndex;
	s:='';
	if i>=0 then
		s:=TB.Items[TB.ItemIndex];
	Find('',Items);
	SetTreeView(TB.Items,szint);
	TC:=TComboBox(Application.FindComponent('PP_COMBO1'));
	if TC<>nil then           { Classok kigyjtse }
		SetTreeView(TC.Items,0);
	TC1:=TComboBox(Application.FindComponent('PP_CLASSTYPE'));
	if (TC1<>nil) and (TC<>nil) then
		begin           { Classok kigyjtse }
		sz:='';
		if TC1.ItemIndex>=0 then
			sz:=TC1.Items[TC1.ItemIndex];
		TC1.Items.Assign(TC.Items);
		if sz<>'' then
			begin
			TC1.ItemIndex:=TC1.Items.IndexOf(sz);
			ClassClick(TC1);
			end;
		end;
	if s<>'' then
		TB.ItemIndex:=TB.Items.IndexOf(s);
	if (TP.Visible) and (TL<>nil) then
		begin
		s:='';
		if TL.ItemIndex>=0 then
			s:=TL.Items[TL.ItemIndex];
		Find(TEd.Text,TL.Items);
		if (TEd.Text<>'') and (s<>'') then
			begin
			TL.ItemIndex:=TL.Items.IndexOf(s);
			if TEd.Text<>'' then
				begin
				sz:=lowercase(TEd.Text);
				van:=False;
				for i:=0 to TEd.Items.Count-1 do
					begin
					if sz=lowercase(TEd.Items[i]) then
						begin
						van:=True;
						break;
						end;
					end;
				if not van then
					TEd.Items.Insert(0,TEd.text);
				end;
			end
		else
			begin
			{ Az adott fggvnyre rllni, ahol most vagyok ! }
			CPos:=GetPos;
			for i:=0 to TL.Items.Count-1 do
				begin
				if TLine(TL.Items.Objects[i]).Line>CPos.Line then
					break;
				end;
			if i=0 then
				i:=1;
			TL.ItemIndex:=i-1;
			end;
		end;
end;

procedure TIDEExpert.GotoPos(Line,Col: longint);
var Editor: TIEditorInterface;
		Pos,TPos: TEditPos;
		Size: TSize;
		TF: TForm;
		TW: TWincontrol;
begin
	Editor:=GetEditor;
	if Editor<>nil then
		begin
		Pos.Line:=Line;
		Pos.Col:=Col;
		Editor.GetView(0).CursorPos:=Pos;
		Size:=Editor.GetView(0).GetViewSize;
		TPos:=Editor.GetView(0).TopPos;
		Pos.Col:=1;
		if (Pos.Line<TPos.Line) or (Pos.Line>TPos.Line+Size.cy) then
			begin
			Pos.Line:=Pos.Line-(Size.cy div 2);
			if Pos.Line<1 then
				Pos.Line:=1;
			Editor.GetView(0).TopPos:=Pos; 
			end;
		{ Editor.GetView(0).TopPos:=Pos; }
		{ TF:=TForm(Application.FindComponent('EditWindow_0')); }
    TF:=FEditWindow;
		if TF<>nil then
			begin
			TW:=TWinControl(TF.FindComponent('Editor'));
			if TW<>nil then
				SetFocus(TW.Handle);
			end;
		end;
end;

function TIDEExpert.GetPos:TEditPos;
var Editor: TIEditorInterface;
		CPos: TEditPos;
begin
	CPos.Line:=0;
	CPos.Col:=0;
	Editor:=GetEditor;
	if Editor<>nil then
		CPos:=Editor.GetView(0).CursorPos;
	Result:=CPos;
end;

function TIDEExpert.GetCharPos:TCharPos;
var Editor: TIEditorInterface;
		Pos: TEditPos;
		CPos: TCharPos;
begin
	CPos.Line:=0;
	CPos.CharIndex:=0;
	Editor:=GetEditor;
	if Editor<>nil then
		begin
		Pos:=Editor.GetView(0).CursorPos;
		Editor.GetView(0).ConvertPos(True,Pos,CPos);
		end;
	Result:=CPos;
end;

function TIDEExpert.GetEditor: TIEditorInterface;
var s: string;
begin
	result:=nil;
	if ToolServices=nil then
		exit;
	// s:=GetEditorName;
	s:=FToolServices.GetCurrentFile;
	FEditorName:=s;
	// if UpperCase(ExtractFileExt(s))='.PAS' then
		begin
		try
		result:=FToolServices.GetModuleInterface(s).GetEditorInterface;
		except end;
		end;
end;

function TIDEExpert.GetLine(Line: longInt): string;
var	Editor: TIEditorInterface;
		CPos: TCharPos;
		Pos: LongInt;
		EPos: TEditPos;
		s: string;
		buffer: array[0..255] of char;
		i: integer;
		EReader: TIEditReader;
begin
	Editor:=GetEditor;
	EPos.Line:=Line;
	EPos.Col:=1;
	s:='';
	if Editor<>nil then
		begin
		Editor.GetView(0).ConvertPos(True,EPos,CPos);
		Pos:=Editor.GetView(0).CharPosToPos(Cpos);
		EReader:=Editor.CreateReader;
		EReader.GetText(Pos,buffer,250);
		Buffer[250]:=#13;
		{ Sor vge jel megkeresse }
		i:=0;
		while true do
			begin
			if buffer[i]=#13 then
				begin
				Buffer[i]:=#0;
				break;
				end;
			i:=i+1;
			end;
		s:=StrPas(Buffer);
		EReader.Free;
		end;
	result:=s;
end;

procedure TIDEExpert.Insert(EPos: TEditPos;s: string);
var	Editor: TIEditorInterface;
		EWriter: TIEditWriter;
		CPos: TCharPos;
		Pos: LongInt;
begin
	Editor:=GetEditor;
	if Editor<>nil then
		begin
		Editor.GetView(0).ConvertPos(True,EPos,CPos);
		Pos:=Editor.GetView(0).CharPosToPos(Cpos);
		EWriter:=Editor.CreateUndoableWriter;
		EWriter.CopyTo(Pos);
		EWriter.Insert(@s[1]);
		EWriter.Free;
		Editor.SetSyntaxHighlighter(shPascal);
		end;
end;


procedure TIDEExpert.Find(search: string;FItems: TStrings);
{ Fggvnyek kigyjtse }
const BufferSize=32000;
var	Editor: TIEditorInterface;
		PPos,ReadSize,Line,LinePos: LongInt;
		buffer,c: PChar;
		i,j: integer;
		EReader: TIEditReader;
		FClass, Remark, FImplement,FType: Boolean;
		s,hatar: string;
		kezd: array[0..1] of char;
		FVisibility: TVisibility;
		cc: char;
		{ time: longint; }


		function Comp(Str1,str2: PChar;len: integer): boolean;
		begin
			result:=False;
			if strLIComp(str1,str2,Len)=0 then
				result:=(Pos(str1[len],hatar)>0) and (Pos(str1[-1],hatar)>0);
		end;

		procedure GetLine;
		begin
			StrLCopy(c,@buffer[LinePos],255);
			{ Sorvgjel megkeresse }
			c[255]:=#13;
			j:=0;
			while (True) do
				begin
				if c[j]=#13 then
					begin
					c[j]:=#0;
					break;
					end;
				j:=j+1;
				end;
			{ Tabok, spacok lemozgatsa ellrl ! }
			while c[0]<>#0 do
				begin
				if (c[0]=#9) or (c[0]=' ') then
					StrCopy(c,c+1)
				else
					break;
				end;
		end;


		procedure AddObject(s: string;FItems: TStrings);
		var FLine: TLine;
		begin
    	if s<>'' then
      	begin
				FLine:=TLine.Create;
				FLine.Line:=Line;
				FLine.FClass:=FClass;
				FLine.FImplement:=FImplement;
				FLine.FVisibility:=FVisibility;
				FItems.AddObject(s,FLine);
        end;
		end;

begin
	FItems.BeginUpdate;
	ListBoxClear(FItems);		{ Objectumok trlse ! }
	s:=FEditorName;
	Editor:=GetEditor;
	if Editor=nil then
		begin
		// ShowMessage('Nem talltam Edit ablakot a FIND fggvnyben!');
		FItems.EndUpdate;
		exit;
		end;
	FImplement:=False;
	FVisibility:=vsNone;
	FType:=False;
	// if Editor<>nil then
		begin
		if search<>'' then		{ A kezd kis s nagy bet ellltsa }
			begin
			search:=search+#0;
			kezd[0]:=search[1];
			kezd[1]:=kezd[0];
			if kezd[0]>='a' then
				kezd[1]:=chr(ord(kezd[1])-32)
			else
				kezd[1]:=chr(ord(kezd[1])+32);
			end;
		hatar:=hatarolo;
		{ time:=GetTickCount; }
		PPos:=0;
		Line:=1;
		LinePos:=0;
		FClass:=False;
		GetMem(buffer,BufferSize);
		GetMem(c,500);
		EReader:=Editor.CreateReader;
		Remark:=False;
		if Search='' then
			TypeStr.Clear;
		while True do
			begin
			ReadSize:=EReader.GetText(PPos,buffer,BufferSize);
			{ ShowMessage(IntToStr(ReadSize)); }
			if ReadSize<5 then
				 break;
			{ Megkeresni, hogy hol a sor vge jel! }
			PPos:=PPos+ReadSize;
			while (ReadSize>0) and (Buffer[ReadSize]<>#10) do
				begin
				PPos:=PPos-1;
				ReadSize:=ReadSize-1;
				end;
			i:=0;
			while (i<ReadSize) do
				begin
				cc:=Buffer[i];
				if cc=#13 then
					begin
					if (Search='') and (FType) then		{ Type rsz kigyjtse }
						begin
						GetLine;
						AddObject(StrPas(c),TypeStr);
						end;
					Line:=Line+1;
					LinePos:=i+2;
					MaxLine:=Line;
					end;
				if (cc='{') and (Search='') then
					Remark:=True;
				if (cc='}') and (Search='') then
					Remark:=False;
				if Remark then
					begin
					i:=i+1;
					continue;
					end;
				if ((cc='c') or (cc='C')) and (not FClass) then
					begin
					if Comp(@Buffer[i],'class',5) then
						begin
						if Search='' then
							begin
							GetLine;
							AddObject(StrPas(c),FItems);
							end;
						FClass:=True;
						FVisibility:=vsNone;
						end;
					end;
				if (cc='t') or (cc='T') then
					begin
					if Comp(@BUffer[i],'type',4) then
						FType:=True;
					end;
				if (cc='i') or (cc='I') then
					begin
					if Comp(@BUffer[i],'implementation',14) then
						begin
						FVisibility:=vsNone;
						FImplement:=True;
						end;
					end;
				if ((cc='e') or (cc='E')) and (FClass) then
					begin
					if Comp(@Buffer[i],'end',3) then
						begin
						FClass:=False;
						FVisibility:=vsNone;
						end;
					end;
				if (search='') then
					begin
					if (cc='c') or (cc='C') or (cc='p') or (cc='P') or (cc='f') or (cc='F') or (cc='d') or (cc='D') then
					{ if (Buffer[i]='P') or (Buffer[i]='p') or (Buffer[i]='f') or (buffer[i]='F') then }
						begin
						if (Comp(@Buffer[i],'procedure',9)) or (Comp(@Buffer[i],'function',8)) or
							(Comp(@Buffer[i],'constructor',11)) or (Comp(@Buffer[i],'destructor',10)) then
							begin
							if (FImplement) then
								FType:=False;
							GetLine;
							if FClass then
								AddObject('  '+StrPas(c),FItems)
							else
								AddObject(StrPas(c),FItems);
							end;
						end;
					end
				else		{ Sz keress }
					begin
					if (Buffer[i]=kezd[0]) or (Buffer[i]=kezd[1]) then
						begin
						hatar:=hatarolo1;
						if Comp(@buffer[i],@search[1],Length(search)-1) then
							begin
							{ Megnzni, hogy ilyen sor nincs e mg ! }
							if (FItems.Count=0) or ((FItems.Count>0) and (TLine(FItems.Objects[FItems.Count-1]).Line<>Line)) then
								begin
								GetLine;
								AddObject(StrPas(c),FItems);
								end;
							end;
						hatar:=hatarolo;
						end;
					end;
				i:=i+1;
				end;
			end;
		FreeMem(Buffer);
		FreeMem(c);
		EReader.Free;
		FItems.EndUpdate;
		{ ShowMessage('Id:'+IntToSTr(GetTickCount-time)); }
		end;
end;

function TIDEExpert.GetEditorName: string;
{
var s: string;
		TF: TForm;
}		
begin
	result:='';
	if FToolServices<>nil then
		result:=FToolServices.GetCurrentFile;
	(*
	TF:=FEditWindow;
	{ TF:=TForm(Application.FindComponent('EditWindow_0')); }
	if TF<>nil then
		begin
		s:=TF.Caption;
		// if lowercase(ExtractFileExt(s))='.pas' then
				begin
				if ExtractFilePath(s)='' then
					s:=ExtractFilePath(ToolServices.GetProjectName)+s;
				result:=s;
				end;
		end;
	 *)	
end;

procedure TIDEExpert.SetTreeView(FItems: TStrings;Szint: integer);
var i: integer;
		FLine: TLine;
		cl,pn,clas: string;

		procedure Trim(var s: string);
		var i: integer;
		begin
			i:=Length(s);
			while i>0 do
				begin
				if s[i]=' ' then
					begin
					SetLength(s,i-1);
					i:=i-1;
					end
				else
					break;
				end;
		end;

		function GetSpace(s: string): string;
		var i: integer;
		begin
			i:=Length(s);
			while (i>0) do
				begin
				if s[i]=' ' then
					begin
					s:=Copy(s,i+1,255);
					break;
					end;
				i:=i-1;
				end;
			result:=s;
		end;

		function Levag(mit: string;var s: string): Boolean;
		var i: integer;
		begin
			result:=False;
			i:=Pos(mit,s);
			if i>0 then
				begin
				s:=Copy(s,1,i-1);
				result:=True;
				end;
		end;


		procedure PrgName(s: string);
		var i: integer;
		begin
			cl:='';
			pn:='';
			i:=Pos('=',s);
			if (i>0) and (Pos(';',s)=0) then
				begin
				s:=Copy(s,1,i-1);
				{ Spacok letvoltsa }
				i:=0;
				while (True) do
					begin
					if i>Length(s) then
						break;
					if s[i]=' ' then
						s:=Copy(s,1,i-1)+Copy(s,i+1,255)
					else
						i:=i+1;
					end;
				cl:=s;
				exit;
				end;
			{ ClassName leszedse }
			i:=Pos('.',s);
			if i>0 then
				begin
				cl:=Copy(s,1,i-1);
				cl:=GetSpace(cl);
				s:=Copy(s,i+1,255);
				end;
			while True do
				begin
				if not Levag(';',s) then
					break;
				end;
			Levag('(',s);
			Trim(s);
			Levag(':',s);
			pn:=GetSpace(s);
		end;


begin
		FItems.Clear;
		for i:=0 to Items.Count-1 do
			begin
			FLine:=TLine(Items.Objects[i]);
			PrgName(Items[i]);
			if (cl<>'') and (pn='') then
				begin
				if Szint=0 then
					FItems.AddObject(cl,FLine);
				clas:=cl;
				end
			else
				begin
				if not FLine.FImplement then
					begin
					if Szint=1 then
						FItems.AddObject(pn+' ('+clas+')',FLine);
					end
				else
					begin
					if cl<>'' then
						pn:=pn+' ('+cl+')';
					if Szint=2 then
						FItems.AddObject(pn,FLine);
					end;
				end;
			end;
end;

procedure TIDEExpert.ListBoxClear(Items: TStrings);
var i: integer;
begin
		for i:=0 to Items.Count-1 do
			begin
			if Items.Objects[i]<>nil then
				Items.Objects[i].Free;
			end;
		Items.Clear;
end;

end.
