Attribute VB_Name = "mdlResizing"
'Form tmretezst vgz ltalnos modul
'Ksztette: Balogh Tams
'2002. oktberben
'szabadon felhasznlhat

Option Explicit

Public Enum enmAnchorTo
  eAnchorTo_TopLeft
  eAnchorTo_TopRight
  eAnchorTo_TopLeftRight
  eAnchorTo_BottomLeft
  eAnchorTo_BottomRight
  eAnchorTo_BottomLeftRight
  eAnchorTo_TopBottomLeft
  eAnchorTo_TopBottomRight
  eAnchorTo_All
End Enum

'Meghvand funkci
Public Function DoResizeControls(ByRef ThisForm As Form) As Boolean

  On Error GoTo Exc_Handler
  
  'A Form_Resize esemny a form betltsekor meghvdik
  'De az a cl, hogy csak akkor fusson le az tmretezsi funkci,
  'ha a form mr inicializlva van
  If Not IsObjectInitialized(ThisForm) Then
    DoResizeControls = True
    Exit Function
  End If
  'Ha a form minimalizlt, akkor sem kvnatos a funkci lefutsa
  If ThisForm.WindowState = vbMinimized Then
    DoResizeControls = True
    Exit Function
  End If
  'A funkci meghvsa
  Call DoResizeChildControls(ThisForm, ThisForm, ThisForm.FormOldWidth, ThisForm.FormOldHeight)
  'Az j mretek rgztse
  ThisForm.FormOldWidth = ThisForm.Width
  ThisForm.FormOldHeight = ThisForm.Height
  
  DoResizeControls = True
Exc_Handler:
  If Err Then
    MsgBox Err.Description & vbCrLf & "Source: " & Err.Source
  End If
  DoResizeControls = False

End Function

'Annak a megllaptsa, hogy egy adott objektum inicializlva van-e
'Megfelel a .NET "object Is Nothing" fggvnynek
Public Function IsObjectInitialized(ByRef ObjectInQuestion As Object) As Boolean
  
  Dim pstrObjectName As String
  
  On Error GoTo Exc_Handler
  
  pstrObjectName = TypeName(IsObjectInitialized)
  If pstrObjectName = "Nothing" Then GoTo Exc_Handler
  IsObjectInitialized = True
  
  Exit Function

Exc_Handler:

  IsObjectInitialized = False

End Function

'Tulajdonkppeni tmretezst vgz funkci
Private Sub DoResizeChildControls(ByRef ContainerForm As Form, ByRef ParentObject As Object, ByVal OldWidth As Long, ByVal OldHeight As Long)
  Dim ctr As Control
  'A rgi mret elmentse
  Dim plngOldWidth As Long
  Dim plngOldHeight As Long
  Dim penmAnchor As enmAnchorTo
  'Vgiglpdelnk a befogad form egyes vezrlelemein
  For Each ctr In ContainerForm
    'Azon, s csak azon vezrlelemekre, melyek a ParentObject elemei
    'vgigfut az tmretezsi mvelet
    If ctr.Container Is ParentObject Then
      If IsNull(ctr.Tag) Or ctr.Tag = "" Then
        penmAnchor = eAnchorTo_TopLeft
      Else
        penmAnchor = ctr.Tag
      End If
      'csak ha nem a default (TopLeft)
      If penmAnchor <> eAnchorTo_TopLeft Then
        'Eredeti mretek elmentse
        plngOldHeight = ctr.Height
        plngOldWidth = ctr.Width
        'A krdses tulajdonsgok szmtsa
        'Left
        If penmAnchor = eAnchorTo_TopRight _
        Or penmAnchor = eAnchorTo_BottomRight _
        Or penmAnchor = eAnchorTo_BottomLeftRight Then
          ctr.Left = ctr.Left + ParentObject.Width - OldWidth
        End If
        'Top
        If penmAnchor = eAnchorTo_BottomRight _
        Or penmAnchor = eAnchorTo_BottomLeft _
        Or penmAnchor = eAnchorTo_BottomLeftRight Then
          ctr.Top = ctr.Top + ParentObject.Height - OldHeight
        End If
        'Width
        If penmAnchor = eAnchorTo_BottomLeftRight _
        Or penmAnchor = eAnchorTo_TopLeftRight _
        Or penmAnchor = eAnchorTo_All Then
          ctr.Width = ctr.Width + ParentObject.Width - OldWidth
        End If
        'Height
        If penmAnchor = eAnchorTo_TopBottomLeft _
        Or penmAnchor = eAnchorTo_TopBottomRight _
        Or penmAnchor = eAnchorTo_All Then
          ctr.Height = ctr.Height + ParentObject.Height - OldHeight
        End If
        'Ha az adott vezrlelem tartalmaz ms vezrlelemeket, akkor
        'azokra is vgigfut a funkci rekurzvan
        If IsControlHasChildControl(ContainerForm, ctr) Then
          Call DoResizeChildControls(ContainerForm, ctr, plngOldWidth, plngOldHeight)
        End If
      End If
    End If
  Next
    
End Sub

'Annak megllaptsa, hogy az adott vezrlelem tartalmaz-e ms vezrlelemeket
Private Function IsControlHasChildControl(ByRef ParentForm As Form, ByRef ControlInQuestion As Object) As Boolean
  Dim ctr As Control
      
  For Each ctr In ParentForm
    If ctr.Container Is ControlInQuestion Then
      IsControlHasChildControl = True
      Exit Function
    End If
  Next

  IsControlHasChildControl = False
      
End Function

